Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# osg::FrameBufferObject Class Reference

Inheritance diagram for osg::FrameBufferObject:

[legend]
List of all members.

## Public Types
typedef std::map< GLenum, FrameBufferAttachment > | AttachmentMap
## Public Member Functions
| FrameBufferObject ()
| FrameBufferObject (const FrameBufferObject &copy, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_StateAttribute (osg, FrameBufferObject,(StateAttribute::Type) 0x101010)
const AttachmentMap & | getAttachmentMap () const
bool | hasAttachment (GLenum attachment_point) const
const FrameBufferAttachment & | getAttachment (GLenum attachment_point) const
void | setAttachment (GLenum attachment_point, const FrameBufferAttachment &attachment)
int | compare (const StateAttribute &sa) const
| Return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs.
void | apply (State &state) const
| apply the OpenGL state attributes.
## Static Public Member Functions
void | deleteFrameBufferObject (unsigned int contextID, GLuint program)
| Mark internal FBO for deletion.
void | flushDeletedFrameBufferObjects (unsigned int contextID, double currentTime, double &availableTime)
| flush all the cached FBOs which need to be deleted in the OpenGL context related to contextID.
## Protected Member Functions
virtual | ~FrameBufferObject ()
FrameBufferObject & | operator= (const FrameBufferObject &)
void | dirtyAll ()

## Member Typedef Documentation

typedef std::map<GLenum, FrameBufferAttachment> osg::FrameBufferObject::AttachmentMap

## Constructor & Destructor Documentation

osg::FrameBufferObject::FrameBufferObject | ( |  | ) |

osg::FrameBufferObject::FrameBufferObject | ( | const FrameBufferObject & | copy,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY
| ) |

virtual osg::FrameBufferObject::~FrameBufferObject | ( |  | ) | `[protected, virtual]`

## Member Function Documentation

void osg::FrameBufferObject::apply | ( | State & | state | ) | const`[virtual]`

| apply the OpenGL state attributes. The global state for the current OpenGL context is passed in to allow the StateAttribute to obtain details on the the current context and state. Implements osg::StateAttribute.

int osg::FrameBufferObject::compare | ( | const StateAttribute & | sa | ) | const`[virtual]`

| Return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs. Implements osg::StateAttribute.

void osg::FrameBufferObject::deleteFrameBufferObject | ( | unsigned int | contextID,
|  | GLuint | program
| ) | `[static]`

| Mark internal FBO for deletion. Deletion requests are queued until they can be executed in the proper GL context.

void osg::FrameBufferObject::dirtyAll | ( |  | ) | `[inline, protected]`

void osg::FrameBufferObject::flushDeletedFrameBufferObjects | ( | unsigned int | contextID,
|  | double | currentTime,
|  | double & | availableTime
| ) | `[static]`

| flush all the cached FBOs which need to be deleted in the OpenGL context related to contextID.

const FrameBufferAttachment & osg::FrameBufferObject::getAttachment | ( | GLenum | attachment_point | ) | const`[inline]`

const FrameBufferObject::AttachmentMap & osg::FrameBufferObject::getAttachmentMap | ( |  | ) | const`[inline]`

bool osg::FrameBufferObject::hasAttachment | ( | GLenum | attachment_point | ) | const`[inline]`

osg::FrameBufferObject::META_StateAttribute | ( | osg | ,
|  | FrameBufferObject | ,
|  | (StateAttribute::Type) | 0x101010
| ) |

FrameBufferObject& osg::FrameBufferObject::operator= | ( | const FrameBufferObject & |  | ) | `[inline, protected]`

void osg::FrameBufferObject::setAttachment | ( | GLenum | attachment_point,
|  | const FrameBufferAttachment & | attachment
| ) | `[inline]`

The documentation for this class was generated from the following file:

- FrameBufferObject